%global release 1

Name:       foreman-installer
Epoch:      1
Version:    1.24.1.22
Release:    %{?prerelease:0.}%{release}%{?prerelease:.}%{?prerelease}%{?nightly}%{?dist}
Summary:    Puppet-based installer for The Foreman
Group:      Applications/System
License:    GPLv3+ and ASL 2.0
URL:        https://theforeman.org
Source0:    http://dogfood.sat.engineering.redhat.com/pulp/isos/Sat6-CI/Library/custom/Source_Files/Satellite_6_7_Source_Files/%{name}-%{version}%{?prerelease:-}%{?prerelease}.tar.bz2

BuildArch:  noarch

Requires:   curl
Requires:   %{?scl_prefix}puppet-agent >= 5.5.10
Requires:   %{?scl_prefix}rubygem(kafo) >= 4.0.0
Requires:   %{?scl_prefix}rubygem(kafo) < 5.0.0
Requires:   foreman-selinux
Requires:   %{?scl_prefix_ruby}ruby(release)

BuildRequires: asciidoc
BuildRequires: rubygem(rake)
BuildRequires: %{?scl_prefix}puppet-agent >= 1.9.0
BuildRequires: %{?scl_prefix}rubygem(kafo) >= 4.0.0
BuildRequires: %{?scl_prefix}rubygem(kafo) < 5.0.0
BuildRequires: puppet-agent-puppet-strings >= 1.2.0
BuildRequires: puppet-agent-puppet-strings < 3

%description
Complete installer for The Foreman life-cycle management system based on Puppet.

%package katello
Summary: Katello installer bits
Group: Applications/System
Provides: katello-installer-base < 3.11.0-1
Obsoletes: katello-installer-base < 3.11.0-1

Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: openssl
Requires: katello-selinux
Requires: katello-certs-tools
Requires: foreman-maintain
Requires: which

%description katello
Various scenarios and tools for the Katello ecosystem

%prep
%setup -q -n %{name}-%{version}%{?prerelease:-}%{?prerelease}

%build
#replace shebangs for SCL
%if %{?scl:1}%{!?scl:0}
  sed -ri '1sX(/usr/bin/ruby|/usr/bin/env ruby)X/usr/bin/%{?scl:%{scl_prefix}}rubyX' bin/foreman-installer bin/foreman-proxy-certs-generate bin/katello-certs-check
%endif
rake build \
  VERSION=%{version} \
  LOCALSTATEDIR=%{_localstatedir} \
  PREFIX=%{_prefix} \
  SBINDIR=%{_sbindir} \
  SYSCONFDIR=%{_sysconfdir} \
  --trace

%install
rake install \
  PREFIX=%{buildroot}%{_prefix} \
  LOCALSTATEDIR=%{buildroot}%{_localstatedir} \
  SBINDIR=%{buildroot}%{_sbindir} \
  SYSCONFDIR=%{buildroot}%{_sysconfdir} \
  --trace

%pretrans katello
# RPM can't change a directory into a symlink
# https://bugzilla.redhat.com/show_bug.cgi?id=447156
for scenario in foreman-proxy-content katello ; do
	MIGRATIONS=%{_sysconfdir}/%{name}/scenarios.d/$scenario.migrations
	if [ -d $MIGRATIONS ] && [ ! -L $MIGRATIONS ] ; then
		mv $MIGRATIONS/.applied %{_sysconfdir}/%{name}/scenarios.d/$scenario-migrations-applied
		rm -rf $MIGRATIONS
	fi
done

%files
%defattr(-,root,root,-)
%doc README.*
%license LICENSE
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/custom-hiera.yaml
%dir %{_sysconfdir}/%{name}/scenarios.d
%{_sysconfdir}/%{name}/scenarios.d/foreman.migrations
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/%{name}/scenarios.d/foreman.yaml
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/%{name}/scenarios.d/foreman-answers.yaml
%config(noreplace) %{_sysconfdir}/%{name}/scenarios.d/foreman-migrations-applied
%{_sbindir}/%{name}
%{_datadir}/%{name}
%{_mandir}/man8

# katello files
%exclude %{_datadir}/%{name}/config/foreman-proxy-content*
%exclude %{_datadir}/%{name}/config/katello*
%exclude %{_datadir}/%{name}/katello
%exclude %{_datadir}/%{name}/katello-certs
%exclude %{_datadir}/%{name}/parser_cache/foreman-proxy-certs.yaml
%exclude %{_datadir}/%{name}/parser_cache/foreman-proxy-content.yaml
%exclude %{_datadir}/%{name}/parser_cache/katello.yaml

%files katello
# common
%{_sbindir}/katello-certs-check
%{_datadir}/%{name}/katello

# foreman-proxy-content scenario
%{_datadir}/%{name}/config/foreman-proxy-content*
%{_datadir}/%{name}/parser_cache/foreman-proxy-content.yaml
%{_sysconfdir}/%{name}/scenarios.d/foreman-proxy-content.migrations
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/%{name}/scenarios.d/foreman-proxy-content.yaml
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/%{name}/scenarios.d/foreman-proxy-content-answers.yaml
%config(noreplace) %{_sysconfdir}/%{name}/scenarios.d/foreman-proxy-content-migrations-applied

# katello scenario
%{_datadir}/%{name}/config/katello*
%{_datadir}/%{name}/parser_cache/katello.yaml
%{_sysconfdir}/%{name}/scenarios.d/katello.migrations
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/%{name}/scenarios.d/katello.yaml
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/%{name}/scenarios.d/katello-answers.yaml
%config(noreplace) %{_sysconfdir}/%{name}/scenarios.d/katello-migrations-applied

# foreman-proxy-certs-generate
%{_datadir}/%{name}/katello-certs
%{_datadir}/%{name}/parser_cache/foreman-proxy-certs.yaml
%{_sbindir}/foreman-proxy-certs-generate

%changelog
* Fri Aug 07 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.22-1
- BZ #1865995: Prevent Candlepin password from appearing on stdout during upgrade

* Mon Jul 06 2020 Patrick Creech <pcreech@redhat.com> - 1:1.24.1.21-1
- BZ #1851158 - Configure default MongoDB WiredTiger cache to be 20% of RAM in the Satellite server

* Wed Mar 11 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.20-1
- BZ #1807151 - Fix crane CA configuration

* Wed Mar 11 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.19-1
- BZ #1654326 - Update KCC branding and add wildcard support

* Tue Mar 10 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.18-1
- BZ #1794007 - Only run proxy config change on server

* Tue Mar 10 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.17-1
- BZ #1772851 - Puppet classes are missing after adding a puppet module and content view publishing

* Mon Mar 09 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.16-1
- BZ #1794007 - moves hook to pre_commit, use kafo config for values
- BZ 1805344: Swap answers and scenario overrides

* Fri Mar 06 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.14-1
- BZ #1743254 - foreman-proxy http port 8000 is enabled while it should be disabled by default

* Fri Mar 06 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.13-1
- BZ #1771425 - Keycloak httpd configuration lost after installer run

* Thu Feb 27 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.12-1
- BZ 1805344: Add hiera config per scenario

* Thu Feb 27 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.11-1
- BZ #1794407 - update puppet-katello reference to pull from downstream

* Tue Feb 18 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.10-1
- BZ #1793092 - candlepin hangs on ExpiredPoolsJob forever while Updating stacked Entitlements
- BZ #1802302 - Remove newline from kcc

* Mon Feb 10 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.8-1
- BZ #1794407 - check that param value exists

* Fri Feb 07 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.7-1
- BZ #1794407 write proxy details

* Mon Feb 03 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.6-1
- BZ #1770646 - log_rotation_size must be set when enabling log_min_duration_statement for PostgreSQL

* Fri Jan 24 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.5-1
- BZ #1792836 - "Update HTTP Proxy details" tasks ends up in paused state.

* Tue Jan 21 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.4-1
- BZ #1770394 - Remove target option, not in docs.

* Fri Jan 17 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.3-1
- BZ #1770552 - Verify MongoDB is on before upgrade

* Fri Jan 17 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.2-1
- Update to 1.24.1.2

* Wed Jan 15 2020 Jenkins User <jenkins-gitlab@redhat.com> - 1:1.24.1.1-1
- BZ #1770394 - Change branding on k-c-c

* Thu Jan 09 2020 Patrick Creech <pcreech@redhat.com> - 1:1.24.1-1
- Release foreman-installer 1.24.1

* Tue Dec 10 2019 Eric D. Helms <ericdhelms@gmail.com> - 1:1.24.0-7
- Release 1.24.0

* Tue Nov 26 2019 Evgeni Golov - 1:1.24.0-0.6.RC3
- Release foreman-installer 1.24.0

* Mon Nov 04 2019 Zach Huntington-Meath <zhunting@redhat.com> - 1:1.24.0-0.6.RC2
- Release 1.24.0-RC2

* Thu Oct 31 2019 Zach Huntington-Meath <zhunting@redhat.com> - 1:1.24.0-0.5.RC1
- Release 1.24.0-RC1

* Fri Oct 18 2019 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.24.0-0.4.develop
- Update package dependencies

* Thu Sep 12 2019 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.24.0-0.3.develop
- Add which as a dependency since it's used in a hook

* Fri Aug 23 2019 Evgeni Golov - 1:1.24.0-0.2.develop
- don't move katello migrations when they point to a symlink

* Tue Jul 30 2019 Evgeni Golov - 1:1.24.0-0.1.develop
- Bump version to 1.24-develop

* Tue May 21 2019 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.23.0-0.2.develop
- Require at least Puppet 5.5.10 (#26844)

* Tue Apr 23 2019 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.23.0-0.1.develop
- Bump version to 1.23-develop

* Fri Mar 08 2019 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.22.0-0.3.develop
- Update to Kafo 3 (#26282)
- Require Puppet >= 5.5.8 (#26339)
- Require puppet-agent-puppet-strings >= 1.2.0

* Fri Feb 22 2019 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.22.0-0.2.develop
- Remove katello-service dependency (#26111)

* Wed Jan 16 2019 Evgeni Golov <evgeni@golov.de> - 1:1.22.0-0.1.develop
- Bump to 1.22

* Wed Dec 12 2018 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.21.0-0.3.develop
- Add Katello installer subpackage

* Wed Oct 24 2018 Adam Price <komidore64@gmail.com> - 1:1.21.0-0.2.develop
- add nightly macro

* Wed Oct 17 2018 Eric D. Helms <ericdhelms@gmail.com> - 1:1.21.0-0.1.develop
- Bump version to 1.21 and reset release

* Wed Jul 25 2018 Eric D. Helms <ericdhelms@gmail.com> - 1:1.20.0-0.1.develop
- Add prerelease macro

* Tue Jul 17 2018 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.20.0-0.develop
- Bump version to 1.20-develop

* Thu May 31 2018 Ewoud Kohl van Wijngaarden <ewoud@kohlvanwijngaarden.nl> - 1:1.19.0-0.develop
- Bump version to 1.19-develop

* Mon Aug 28 2017 Daniel Lobato Garcia <me@daniellobato.me> - 1.17.0-0.develop
- Bump version to 1.17-develop

* Wed Mar 29 2017 Eric D Helms <ericdhelms@gmail.com> - 1.16.0-0.develop
- Bump version to 1.16-develop

* Tue Dec 06 2016 Dominic Cleal <dominic@cleal.org> - 1.15.0-0.develop
- Bump version to 1.15-develop

* Wed Sep 07 2016 Dominic Cleal <dominic@cleal.org> - 1.14.0-0.develop
- Bump version to 1.14-develop

* Tue May 31 2016 Dominic Cleal <dominic@cleal.org> - 1.13.0-0.develop
- Bump version to 1.13-develop

* Fri Feb 19 2016 Dominic Cleal <dominic@cleal.org> - 1.12.0-0.develop
- Bump version to 1.12-develop

* Wed Oct 07 2015 Dominic Cleal <dcleal@redhat.com> - 1.11.0-0.develop
- Bump version to 1.11-develop

* Fri Jun 26 2015 Dominic Cleal <dcleal@redhat.com> - 1.10.0-0.develop
- Bump version to 1.10-develop

* Tue Mar 03 2015 Dominic Cleal <dcleal@redhat.com> - 1.9.0-0.develop
- Bump version to 1.9-develop

* Tue Oct 28 2014 Dominic Cleal <dcleal@redhat.com> - 1.8.0-0.develop
- Bump version to 1.8-develop

* Mon Aug 11 2014 Dominic Cleal <dcleal@redhat.com> - 1.7.0-0.develop
- Bump version to 1.7-develop

* Wed Apr 16 2014 Dominic Cleal <dcleal@redhat.com> - 1.6.0-0.develop
- Bump to version 1.6-develop

* Thu Jan 16 2014 Dominic Cleal <dcleal@redhat.com> - 1.5.0-0.develop
- Bump to version 1.5-develop

* Thu Nov 21 2013 Dominic Cleal <dcleal@redhat.com> - 1.4.0-0.develop
- Bump and change versioning scheme (#3712)

* Fri Nov 08 2013 Marek Hulan <mhulan[@]redhat.com> - 1.3.9999-4
- upgrade to kafo 0.3.0

* Thu Sep 12 2013 Marek Hulan <mhulan[@]redhat.com> - 1.3.9999-3
- set config flag on configuration files

* Thu Sep 12 2013 Marek Hulan <mhulan[@]redhat.com> - 1.3.9999-2
- config files packaging fix

* Wed Sep 11 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.3.9999-1
- bump to version 1.3-develop

* Mon Jul 22 2013 Marek Hulan <mhulan[@]redhat.com> - 1.2.9999-3
- new files structure for a installer based on kafo

* Mon Jul 22 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.2.9999-2
- adding foreman_api as a dependency

* Thu May 23 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.2.9999-1
- initial version
